//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/text_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializeparagraphNode")
inline fun paragraphNode(block: gg.dsepractice.chinese.v1alpha1.ParagraphNodeKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ParagraphNode =
  gg.dsepractice.chinese.v1alpha1.ParagraphNodeKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.ParagraphNode.newBuilder()).apply { block() }._build()
object ParagraphNodeKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.ParagraphNode.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.ParagraphNode.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.ParagraphNode = _builder.build()

    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     */
    var fullText: kotlin.String
      @JvmName("getFullText")
      get() = _builder.getFullText()
      @JvmName("setFullText")
      set(value) {
        _builder.setFullText(value)
      }
    /**
     * <code>string full_text = 1 [json_name = "fullText"];</code>
     */
    fun clearFullText() {
      _builder.clearFullText()
    }

    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class NodesProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
     val nodes: com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>
      @kotlin.jvm.JvmSynthetic
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getNodesList()
      )
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     * @param value The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addNodes")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>.add(value: gg.dsepractice.chinese.v1alpha1.SegmentNode) {
      _builder.addNodes(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     * @param value The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignNodes")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>.plusAssign(value: gg.dsepractice.chinese.v1alpha1.SegmentNode) {
      add(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     * @param values The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllNodes")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>.addAll(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.SegmentNode>) {
      _builder.addAllNodes(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     * @param values The nodes to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllNodes")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>.plusAssign(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.SegmentNode>) {
      addAll(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     * @param index The index to set the value at.
     * @param value The nodes to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setNodes")
    operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>.set(index: kotlin.Int, value: gg.dsepractice.chinese.v1alpha1.SegmentNode) {
      _builder.setNodes(index, value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.SegmentNode nodes = 2 [json_name = "nodes"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearNodes")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.SegmentNode, NodesProxy>.clear() {
      _builder.clearNodes()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.ParagraphNode.copy(block: gg.dsepractice.chinese.v1alpha1.ParagraphNodeKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.ParagraphNode =
  gg.dsepractice.chinese.v1alpha1.ParagraphNodeKt.Dsl._create(this.toBuilder()).apply { block() }._build()

